import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.tools.JavaCompilerTool;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import javax.tools.JavaCompilerTool.CompilationTask;

public class JavaCompilerDemo {

    public static void main(String[] args) {
        // specify the source code, change accordingly
        String sourceFile = "c:/temp/HelloWorld.java";
        JavaCompilerTool compiler = 
                ToolProvider.getSystemJavaCompilerTool();
        // get the standard JavaFileManager implementation 
        // for this tool 
        StandardJavaFileManager fileManager = 
                compiler.getStandardFileManager(null);

        // prepare the source file(s) to compile
        List<File> sourceFileList = new ArrayList<File>();
        sourceFileList.add(new File(sourceFile));
        Iterable<? extends JavaFileObject> compilationUnits =
                fileManager.getJavaFileObjectsFromFiles(
                sourceFileList);
        CompilationTask task = compiler.getTask(null, 
                fileManager, null, null, null, compilationUnits);
        task.run();
        boolean result = task.getResult();
        if (result) {
            System.out.println("Compilation was successful");
        } else {
            System.out.println("Compilation failed");
        }
        // our task is completed, now close the file manager
        try {
            fileManager.close();
        } catch (IOException e) {
        }
    }
}
